function varargout = MHO_simulace(varargin)
% MHO_SIMULACE MHO_simulace.fig
%--------------------------------------------------------------------------
%  Tato program simuluje chovn systmu hromadn obsluhy M/M/m.
%--------------------------------------------------------------------------
% Model M/M/m s m-linkami obshluhy a neomezenym poctem zakazniku v systemu. 
% Pokud pozadavek prichaz k lince, kter ma obsazeny vech linky obsluhy 
% zaradi se do fronty a ceka na obsluhu.
% Pokud neni splnena podminka stability ro=lambda/mi*m system by se nemohl 
% stabilizovat z cehoz plyne narust fronty nade vsechny meze. Aby bylo 
% mozno spustit simulaci mus bt tato podmnka splnna. Dle mus bt 
% splnn, e lambda,mi,m a poet simulac mus bt >0.
%-------------------------------------------------------------------------- 

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @MHO_simulace_OpeningFcn, ...
                   'gui_OutputFcn',  @MHO_simulace_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
    
end
% End initialization code - DO NOT EDIT

% --- Executes just before MHO_simulace is made visible.
function MHO_simulace_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to MHO_simulace (see VARARGIN)

% Choose default command line output for MHO_simulace
handles.output = hObject;

axes(handles.model)
imshow('Model_MMm.png')

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes MHO_simulace wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = MHO_simulace_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function Lambda_edit_Callback(hObject, eventdata, handles)
% hObject    handle to Lambda_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Lambda_edit as text
%        str2double(get(hObject,'String')) returns contents of Lambda_edit as a double


% --- Executes during object creation, after setting all properties.
function Lambda_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Lambda_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function mi_edit_Callback(hObject, eventdata, handles)
% hObject    handle to mi_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mi_edit as text
%        str2double(get(hObject,'String')) returns contents of mi_edit as a double


% --- Executes during object creation, after setting all properties.
function mi_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mi_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function PocKan_edit_Callback(hObject, eventdata, handles)
% hObject    handle to PocSim_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PocSim_edit as text
%        str2double(get(hObject,'String')) returns contents of PocSim_edit as a double

% --- Executes during object creation, after setting all properties.
function PocKan_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PocSim_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function PocSim_edit_Callback(hObject, eventdata, handles)
% hObject    handle to PocSim_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PocSim_edit as text
%        str2double(get(hObject,'String')) returns contents of PocSim_edit as a double


% --- Executes during object creation, after setting all properties.
function PocSim_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PocSim_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in Simulace.
function Simulace_Callback(hObject, eventdata, handles)
% hObject    handle to Simulace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Odstrann pedchozch zadanch parametr a vpotench hodnot

set(handles.text11,'String','');
set(handles.text12,'String','');
set(handles.text13,'String','');
set(handles.text15,'String','');
set(handles.text16,'String','');
set(handles.text17,'String','');

set(handles.text26,'String','');
set(handles.text27,'String','');
set(handles.text28,'String','');
set(handles.text29,'String','');
set(handles.text30,'String','');
set(handles.text31,'String','');

set(handles.text32,'String','');
set(handles.text33,'String','');
set(handles.text35,'String','');
set(handles.text37,'String','');
set(handles.text39,'String','');
set(handles.text41,'String','');

set(handles.text42,'String','');
set(handles.text43,'String','');

% Naten vstupnich parametru
lambda=str2double(get(handles.Lambda_edit,'String'));
mi=str2double(get(handles.mi_edit,'String'));
PocKan=str2double(get(handles.PocKan_edit,'String'));
PocSim=str2double(get(handles.PocSim_edit,'String'));
save ('PocKan.txt','PocKan','-ASCII')
save ('PocSim.txt','PocSim','-ASCII')

ro=lambda/mi;
% Intenzita provozu systm M/M/1 mus bt splna podmnka ro<1
% jinak by fronta rostla nade vechny meze
PodStab=ro/PocKan;
% Intenzita provozu systm M/M/m PodStab < 1 
% jinak by fronta rostla nade vechny meze


if lambda<=0
   set(handles.text32,'String','Intenzita vstupu mus bt vt ne 0');
else
    
    if mi<=0
       set(handles.text32,'String','Intenzita obsluhy mus bt vt ne 0');
    else
        
        if PocKan<=0
           set(handles.text32,'String','Poet obslunch linek mus bt vt ne 0');
        else
            
            if PocSim<=0
               set(handles.text32,'String','Poet simulac mus bt vt ne 0'); 
            else
                
                if PodStab>=1
                   set(handles.text33,'String',' !! Intenzita provozu ro=lambda/mi*m musi splnit podmnku stabilizace ro<1 !!'); 
                else      
                   
                    
IntMezPri=exprnd(1/lambda,PocSim,1);
IntMezPri_min=IntMezPri*60;
%IntMezPri      ... Intervaly mezi pchody poadavk do SHO
%IntMezPri_min  ... Intervaly mezi pchody poadavk v minutch do SHO
OkaPriPoz=cumsum(IntMezPri);
OkaPriPoz_min=OkaPriPoz*60;
save ('OkaPriPoz.txt','OkaPriPoz','-ASCII')
%OkaPriPoz      ... Okamiky pchodu poadavk do SHO
%OkaPriPoz_min  ... Okamiky pchodu poadavk v minutch do SHO
DobObsPoz=exprnd(1/mi,PocSim,1);
DobObsPoz_min=DobObsPoz*60;
save ('DobObsPoz.txt','DobObsPoz','-ASCII')
%DobObsPoz          ... Doba obsluhy poadavku v SHO
%DobObsPoz_min      ... Doba obsluhy poadavku v minutch v SHO

for i=1:PocKan
    OkaOdcPoz(i)=OkaPriPoz(i)+DobObsPoz(i);
    %OkaOdcPoz  ... Okamzik odchodu poadavku ze SHO
    Pom_vek(i)=OkaOdcPoz(i);
    %Pom_vek    ... Pomocn vektor pro ukldn odchod poadavk na
    %               jednotlivch kanlech
    VyuKan(i)=i;
    %VyuKan    ... Linka na kterm je dan poadavek zpracovvn
    NevLinObs(i)=0;
    %VyuKan    ... Nevyuit linky, prostoj dan linky
end
     
for i=(PocKan+1):PocSim
   
    if OkaPriPoz(i)>min(Pom_vek)
       DobCekFro(i)=0;
       NevLinObs(i)=OkaPriPoz(i)-min(Pom_vek);
    else 
       DobCekFro(i)=min(Pom_vek)-OkaPriPoz(i);
       NevLinObs(i)=0;
    end
    
    ZacObsPoz(i)=OkaPriPoz(i)+DobCekFro(i);
    %ZacObsPoz  ... Zatek obsluhy poadavku v SHO
    %DobCekFro  ... Doba ekn poadavku na obsluhu v SHO
    OkaOdcPoz(i)=ZacObsPoz(i)+DobObsPoz(i);
                     
   for j=1:PocKan 
           if Pom_vek(j)==min(Pom_vek)
              Pom_vek(j)=OkaOdcPoz(i);
              VyuKan(i)=j;
              break 
           end                     
   end
end

ZacObsPoz=ZacObsPoz';
DobCekFro=DobCekFro';
OkaOdcPoz=OkaOdcPoz';
NevLinObs=NevLinObs';

ZacObsPoz_min=ZacObsPoz*60;
%ZacObsPoz_min  ... Zatek obsluhy poadavku v minutach v SHO
DobCekFro_min=DobCekFro*60;
%DobCekFro_min  ... Doba ekn poadavku na obsluhu v minutach v SHO
OkaOdcPoz_min=OkaOdcPoz*60;
%OkaOdcPoz_min  ... Okamzik odchodu poadavku v minutch ze SHO
NevLinObs_min=NevLinObs*60;
%NevLinObs_min  ... Nevyuit linky, prostoj dan linky v minutch v SHO

save ('VyuKan.txt','VyuKan','-ASCII')
save ('IntMezPri__min.txt','IntMezPri_min','-ASCII')
save ('OkaPriPoz__min.txt','OkaPriPoz_min','-ASCII')
save ('DobObsPoz__min.txt','DobObsPoz_min','-ASCII')
save ('DobCekFro__min.txt','DobCekFro_min','-ASCII')
save ('OkaOdcPoz__min.txt','OkaOdcPoz_min','-ASCII')

%-------------------------------------------------------------------------
%   VYSTUPN SIMULOVAN PARAMETRY systmu hromadn obsluhy M/M/m
%-------------------------------------------------------------------------
%prumer_PDMP ... Prmrn doba mezi pchody poadavk v minutch do SHO
%prumer_PDO ... Prmrn doba obsluhy poadavku v minutch v SHO
%prumer_PDCVF ... Prmrn doba ekn poadavku na obsluhu v minutach v SHO
%prumer_PDSVS ... Prmrn doba strven poadavku v minutach v SHO
%prumer_NLO... Prmn doba nevyuit linek obsluhy
%IntPro... intenzita provozu


prumer_PDMP=mean(IntMezPri_min);
prumer_PDO=mean(DobObsPoz_min);
prumer_PDCVF=mean(DobCekFro_min);
prumer_PDSVS=mean(prumer_PDO+prumer_PDCVF);
prumer_NLO=mean(NevLinObs_min);
IntPro=1-(prumer_NLO*3/max(OkaOdcPoz_min));

set(handles.text11,'String',prumer_PDO);
set(handles.text12,'String',prumer_PDCVF);
set(handles.text13,'String',prumer_PDSVS);
set(handles.text37,'String',IntPro);

%CasOkam ...serazeni casovych okamziky prichodu a odchodu jednotlivch
%           pozadavku do a z SHO
CasOkam=[OkaPriPoz;OkaOdcPoz];
CasOkam=sort(CasOkam);

DobCasOka=diff(CasOkam); 
%DobCasOka ...delka casoveho okamziku serazench casovych okamziku
%prichodu a odchodu

%PocPozSys... pocet pozadavku v systemu v prubehu simulace
PocPozSys(1)=1;
for i=2:2*PocSim
    citac=0;
    for j=1:PocSim
        if (OkaPriPoz(j)==CasOkam(i))
            citac=citac+1;
         end
        if (OkaOdcPoz(j)==CasOkam(i)) 
            citac=citac-1;
        end 
    end
    PocPozSys(i)=PocPozSys(i-1)+citac;
    %pokud prijde pozadavek zvysi se pocet pozadavku v systemu o 1
    %pokud odejde pozadavek snizi se pocet pozadavku v systemu o 1
end

PocPozSys_graf=PocPozSys;
PocPozSys_graf=PocPozSys_graf';
CasOkamMin=CasOkam*60;
SysHis=[CasOkamMin PocPozSys_graf];
save ('SysHis.txt','SysHis','-ASCII')

PocPozSys=PocPozSys(1:2*PocSim-1);
%Odstraneni posledniho pozadavku, ktery je nulovy (ochod poslednho poztadavku)
PocPozSys=PocPozSys';

[PocPozSys,index]=sort(PocPozSys); 
DobCasOka=DobCasOka(index); 
pocet=(2*PocSim-1);

j=1;
CisPoz(j)=PocPozSys(j);
%CisPoz... jednotlive pozadavky (0,1,2,...) v SHO
CetPozSys(j)=1;
%CetPozSys... cetnost jednotlivych pozadavku v SHO
for i=1:(pocet-1)
    if (PocPozSys(i)==PocPozSys(i+1)) 
        CetPozSys(j)=CetPozSys(j)+1;
    else j=j+1;
        CetPozSys(j)=1;
        CisPoz(j)=PocPozSys(i+1);
    end
end

MaxPozSys=length(CisPoz);
CisPoz=CisPoz';
set(handles.text39,'String',(mat2str(CisPoz)));
set(handles.text41,'String',(mat2str(CisPoz)));
CumSum=cumsum(CetPozSys);

%CelDobCasOka ... celkove doby prislusnych jednotlivych pozadavku
%                 prislusneho poctu

CelDobCasOka(1)=CasOkam(1)+sum(DobCasOka(1:CumSum(1)))
for i=2:MaxPozSys
    CelDobCasOka(i)=sum(DobCasOka(CumSum(i-1)+1:CumSum(i)));
end

CelDobCasOka_min=CelDobCasOka*60;
%CelDobCasOka ... celkove doby prislusnych jednotlivych pozadavku
%                 prislusneho poctu pozadavku v min


%--------------------------------------------------------------------------
%   VYSTUPN SIMULOVAN PARAMETRY systmu hromadn obsluhy M/M/m
%--------------------------------------------------------------------------
%PravSim ... pravdepodobnosti jednotlivych poctu zakazniku v systemu
%N...prumerny pocet poctu poadavk v systemu
%Nfr...prumerny pocet pozadavku ve fronte
%Ns...prumerny pocet obsluhovanych pozadavku

PravSim=CelDobCasOka_min/max(OkaOdcPoz_min);
N=PravSim*CisPoz;
Nfr=PravSim((PocKan+1):MaxPozSys)*CisPoz(1:MaxPozSys-PocKan);
Ns=N-Nfr;

PravSim=PravSim';
set(handles.text15,'String',N);
set(handles.text16,'String',Nfr);
set(handles.text17,'String',Ns);
set(handles.text43,'String',(mat2str(PravSim,3)));

%-------------------------------------------------------------------------
% ANALYTICK EEN systmu hromadn obsluhy M/M/m
%-------------------------------------------------------------------------
% EN...stredni hodnota poctu poadavk v systemu
% ENf...stredni hodnota poctu poadavk ve fronte
% ENs...stredni hodnota poctu poadavk obsluhovanch
% ETs...stredn hodnota doby obsluhy poadavku
% ETf...stredni hodnota doby strven poadavku ve front
% ET... stredni hodnota doby strven poadavku v systmu
% p0... pravdepodobnost ze v systemu nebude zadny pozadavek
% PravVyp(j). pravdpodobnost, e v systmu bude j poadavk

% ro=lambda/mi;
% Intenzita provozu systm M/M/1 mus bt splna podmnka ro<1
% jinak by fronta rostla nade vechny meze
% PodStab=ro/PocKan;
% Intenzita provozu systm M/M/m PodStab < 1 
% jinak by fronta rostla nade vechny meze

Suma=0;
for j=0:PocKan-1 
    Suma=Suma+(ro^j)/factorial(j);  
end;
p0=1/(Suma+((ro^PocKan)/factorial(PocKan))*(1/(1-(ro/PocKan))));  
    
for j=1:PocKan
    PravVyp(j)=p0*((ro^j)/factorial(j));
end;

for j=PocKan+1:MaxPozSys
    PravVyp(j)=p0*((ro^j)/(PocKan^j))*((PocKan^PocKan)/(factorial(PocKan)));
end;
    
ENs=ro;
ENf=p0*lambda*mi*((ro^PocKan)/((factorial(PocKan-1))*((PocKan*mi-lambda)^2)));
EN=ENs+ENf;

ETs=(1/mi)*60;
ETf=(ENf*(1/lambda))*60;
ET=(ETs+ETf);

PravVyp=PravVyp';
set(handles.text26,'String',ETs);
set(handles.text27,'String',ETf);
set(handles.text28,'String',ET);

set(handles.text29,'String',EN);
set(handles.text30,'String',ENf);
set(handles.text31,'String',ENs);
set(handles.text35,'String',PodStab);
set(handles.text42,'String',(mat2str(PravVyp,3)));

                end
                      
            end
                
        end 
    
    end
    
end

% --- Executes on button press in OdsParSim.
function OdsParSim_Callback(hObject, eventdata, handles)
% hObject    handle to OdsParSim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.Lambda_edit,'String','');
set(handles.mi_edit,'String','');
set(handles.PocKan_edit,'String','');
set(handles.PocSim_edit,'String','');

set(handles.text11,'String','');
set(handles.text12,'String','');
set(handles.text13,'String','');
set(handles.text15,'String','');
set(handles.text16,'String','');
set(handles.text17,'String','');

set(handles.text26,'String','');
set(handles.text27,'String','');
set(handles.text28,'String','');
set(handles.text29,'String','');

set(handles.text30,'String','');
set(handles.text31,'String','');
set(handles.text32,'String','');
set(handles.text33,'String','');
set(handles.text35,'String','');
set(handles.text37,'String','');
set(handles.text39,'String','');
set(handles.text41,'String','');
set(handles.text42,'String','');
set(handles.text43,'String','');

% --- Executes on button press in Graf_Sim_Hodnot.
function Graf_Sim_Hodnot_Callback(hObject, eventdata, handles)
% hObject    handle to Graf_Sim_Hodnot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Graf_Sim_Hodnot

% --- Executes on button press in Porovnani.
function Porovnani_Callback(hObject, eventdata, handles)
% hObject    handle to Porovnani (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Porovnani

% --- Executes on button press in Napoveda.
function Napoveda_Callback(hObject, eventdata, handles)
% hObject    handle to Napoveda (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Napoveda

% --- Executes on button press in zavrit.
function zavrit_Callback(hObject, eventdata, handles)
% hObject    handle to zavrit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
delete ('PocSim.txt','PocKan.txt','VyuKan.txt')
delete ('DobObsPoz.txt','OkaPriPoz.txt','SysHis.txt')
delete ('OkaOdcPozPor__min.txt','DobCekFroPor__min.txt')
delete ('IntMezPri__min.txt','OkaPriPoz__min.txt','DobObsPoz__min.txt','DobCekFro__min.txt','OkaOdcPoz__min.txt')
close
